import { ArrayOps } from '../lift';
declare module '../../wrapper' {
    interface ArrayOps<A> {
        distinct: typeof distinct;
    }
}
/**
 * Creates an array without any duplicate item.
 * If a key function is passed, items will be compared based on the result of that function;
 * if not, they will be compared using strict equality.
 */
export declare function distinct<A>(this: ArrayOps<A>, getKey?: (item: A, index: number) => string | number): ArrayOps<A>;
