import { ObjectOps } from '../lift';
declare module '../../wrapper' {
    interface ObjectOps<A> {
        add: typeof add;
    }
}
/**
 * Adds a key/value to this heterogeneous object.
 * To add a (nullable) key to an object while preserving its type, use "update()" instead.
 * To add a key to a homogeneous key/value object, use "assoc" instead.
 */
export declare function add<A, K extends string, V>(this: ObjectOps<A>, key: K, value: V): ObjectOps<A & {
    [P in K]: V;
}>;
