"use strict";
exports.__esModule = true;
var lift_1 = require("../lift");
/**
 * Adds a key/value to this heterogeneous object.
 * To add a (nullable) key to an object while preserving its type, use "update()" instead.
 * To add a key to a homogeneous key/value object, use "assoc" instead.
 */
function add(key, value) {
    var obj = this.value(), result = {};
    Object.keys(obj).forEach(function (key) { result[key] = obj[key]; });
    result[key] = value;
    return new lift_1.ObjectOps(result);
}
exports.add = add;
lift_1.ObjectOps.prototype.add = add;
//export function add<A, K extends string, V>(this: ObjectOps<A>, key: K, value: V): ObjectOps<A & Record<K, V>> {
