"use strict";
exports.__esModule = true;
var lift_1 = require("../lift");
/**
 * Removes a key/value from this heterogeneous object.
 * To remove a (nullable) key from an object while preserving its type, use "update()" instead.
 * To remove a key from a homogeneous key/value object, use "dissoc" instead.
 */
function remove(keyToRemove) {
    var obj = this.value();
    var keyToRemoveStr = keyToRemove.toString();
    var result = {};
    Object.keys(obj).forEach(function (key) { if (key !== keyToRemoveStr)
        result[key] = obj[key]; });
    return new lift_1.ObjectOps(result);
}
exports.remove = remove;
lift_1.ObjectOps.prototype.remove = remove;
