import { ArrayOps, ObjectOps, NumberOps, StringOps, DateOps, Wrapper } from './lift';
declare module '../wrapper' {
    interface ArrayOps<A> {
        transform: typeof transform;
    }
}
declare module '../wrapper' {
    interface ObjectOps<A> {
        transform: typeof transform;
    }
}
declare module '../wrapper' {
    interface NumberOps {
        transform: typeof transform;
    }
}
declare module '../wrapper' {
    interface StringOps {
        transform: typeof transform;
    }
}
declare module '../wrapper' {
    interface DateOps {
        transform: typeof transform;
    }
}
/**
 * Runs an arbitrary function to transform this wrapper into a Number wrapper
 */
export declare function transform<A>(this: Wrapper<A>, func: (source: A) => number): NumberOps;
/**
 * Runs an arbitrary function to transform this wrapper into a number wrapper
 */
export declare function transform<A>(this: Wrapper<A>, func: (source: A) => NumberOps): NumberOps;
/**
 * Runs an arbitrary function to transform this wrapper into a string wrapper
 */
export declare function transform<A>(this: Wrapper<A>, func: (source: A) => string): StringOps;
/**
 * Runs an arbitrary function to transform this wrapper into a string wrapper
 */
export declare function transform<A>(this: Wrapper<A>, func: (source: A) => StringOps): StringOps;
/**
 * Runs an arbitrary function to transform this wrapper into a boolean wrapper
 */
export declare function transform<A>(this: Wrapper<A>, func: (source: A) => boolean): boolean;
/**
 * Runs an arbitrary function to transform this wrapper into a date wrapper
 */
export declare function transform<A>(this: Wrapper<A>, func: (source: A) => Date): DateOps;
/**
 * Runs an arbitrary function to transform this wrapper into a date wrapper
 */
export declare function transform<A>(this: Wrapper<A>, func: (source: A) => DateOps): DateOps;
/**
 * Runs an arbitrary function to transform this wrapper into a array wrapper
 */
export declare function transform<A, B>(this: Wrapper<A>, func: (source: A) => B[]): ArrayOps<B>;
/**
 * Runs an arbitrary function to transform this wrapper into a array wrapper
 */
export declare function transform<A, B>(this: Wrapper<A>, func: (source: A) => ArrayOps<B>): ArrayOps<B>;
/**
 * Runs an arbitrary function to transform this wrapper into an object wrapper
 */
export declare function transform<A, B>(this: Wrapper<A>, func: (source: A) => B): ObjectOps<B>;
/**
 * Runs an arbitrary function to transform this wrapper into an object wrapper
 */
export declare function transform<A, B>(this: Wrapper<A>, func: (source: A) => ObjectOps<B>): ObjectOps<B>;
