import { ArrayOps } from '../lift';
declare module '../../wrapper' {
    interface ArrayOps<A> {
        filter: typeof filter;
    }
}
/**
 * Filters this array by aplying a predicate to all items and refine its type.
 */
export declare function filter<A, T extends A>(this: ArrayOps<A>, predicate: (item: A, index: number) => item is T): ArrayOps<T>;
/**
 * Filters this array by aplying a predicate.
 */
export declare function filter<A>(this: ArrayOps<A>, predicate: (item: A, index: number) => boolean): ArrayOps<A>;
