import { ObjectOps } from '../lift';
declare module '../../wrapper' {
    interface ObjectOps<A> {
        dissoc: typeof dissoc;
    }
}
/**
 * Removes a key/value from this homogeneous key/value object.
 * To remove a (nullable) key from an object while preserving its type, use "update()" instead.
 * To remove a key from an object and create a new type, use "remove()"
 */
export declare function dissoc<K extends string | number | symbol, V>(this: ObjectOps<Record<K, V>>, key: K): ObjectOps<Record<K, V>>;
